(defun emacs-cat (file-containing-list)
  "Concatenate files, like cat(1), but using their different coding systems.
The given FILE-CONTAINING-LIST contains the list of files to concatenate.

CAVEATS: 
1. This is not bullet proof.
   If the file you give it is not meaningful,
   then neither will be your results.

2. Emacsy considerations, like narrowing, are not taken into account."
  (interactive "fFilename containing the list? ")
  (let ((fname "emacs-cat")
	(files (delete "" (lines-in-file file-containing-list)))
	(cat-buffer (get-buffer-create "*Cat Output*")))
    (set-buffer cat-buffer)
    (erase-buffer)
    (mapc (lambda (fn)
	    (let ((other-buffer (find-file-noselect fn t nil nil))) ; You may want different options here. Maybe nil nil nil or nil nil t.
	      (insert-buffer other-buffer)))
	  files)
    (pop-to-buffer cat-buffer)
    (message "You can save your concatenated files now.")))


(defun lines-in-file (filename)
  "Return a list of strings, each of which is one line in the given FILENAME."
  (let ((fname "lines-in-file")
	(buffer-contents)
	(lines)
	)
    (save-excursion
      (set-buffer (find-file-noselect filename t nil nil))
      (setq lines (split-string (buffer-substring-no-properties (point-min) (point-max)) "[\n\r]")))
    lines))
